> ## Documentation Index
> Fetch the complete documentation index at: https://algolia.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create an authentication resource

> Creates a new authentication resource.

**Required ACL:** `addObject`, `deleteIndex`, `editSettings`


## OpenAPI

````yaml specs/ingestion.yml post /1/authentications
openapi: 3.1.0
info:
  title: Ingestion API
  summary: >-
    The Ingestion API lets you connect third-party services and platforms with
    Algolia and schedule tasks to ingest your data
  description: >
    The Ingestion API powers the no-code [data
    connectors](https://dashboard.algolia.com/connectors).


    ## Base URLs


    Base URLs for the Ingestion API:


    - `https://data.us.algolia.com`

    - `https://data.eu.algolia.com`


    Use the URL that matches your [analytics
    region](https://dashboard.algolia.com/account/infrastructure/analytics).


    **All requests must use HTTPS.**


    ## Authentication


    Add these headers to authenticate requests:


    - `x-algolia-application-id`. Your Algolia application ID.

    - `x-algolia-api-key`. An API key with the necessary permissions to make the
    request.
      The required access control list (ACL) to make a request is listed in each endpoint's reference.

    You can find your application ID and API key in the [Algolia
    dashboard](https://dashboard.algolia.com/account/api-keys).


    ## Request format


    Request bodies must be JSON objects.


    ## Response status and errors


    Response bodies are JSON objects.


    Successful responses return `2xx` statuses. Client errors return `4xx`
    statuses. Server errors return `5xx` statuses.

    Error responses have a `message` property with more information.


    ## Version


    The current version of the Ingestion API is version 1, indicated by the
    `/1/` in each endpoint's URL.
  version: 1.0.0
servers:
  - url: https://data.{region}.algolia.com
    variables:
      region:
        description: The region where your Algolia application is hosted.
        enum:
          - eu
          - us
        default: us
security:
  - appId: []
    apiKey: []
tags:
  - name: authentications
    x-displayName: Authentications
    description: >-
      Authentication resources describe how to connect to a source or
      destination.
  - name: destinations
    x-displayName: Destinations
    description: >
      Destinations are Algolia products or features where your data should be
      used, such as a search index or events.

      Algolia destinations require authentication with the `algolia` type.

      You can reference authentications by their ID when creating destinations.
  - name: observability
    x-displayName: Observability
    description: >-
      Check the status and details of your task runs. A run is one instance of a
      configured task.
  - name: sources
    x-displayName: Sources
    description: >
      Sources are third-party platforms or services from where you want to
      ingest your data.

      Sources may require authentication. To interact with such sources, you can
      reference an authentication resource by its ID.
  - name: tasks
    x-displayName: Tasks
    description: >
      Tasks contain information how your data should be read from a source and
      stored in a destination.

      Tasks have _triggers_ which determine when the task should run.
  - name: transformations
    x-displayName: Transformations
    description: >
      Transformations let you transform a record before it gets indexed in
      Algolia.
paths:
  /1/authentications:
    post:
      tags:
        - authentications
      summary: Create an authentication resource
      description: Creates a new authentication resource.
      operationId: createAuthentication
      requestBody:
        description: ''
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/AuthenticationCreate'
        required: true
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AuthenticationCreateResponse'
        '400':
          $ref: '#/components/responses/BadRequest'
      x-codeSamples:
        - lang: csharp
          label: C#
          source: |-
            // Initialize the client
            var client = new IngestionClient(
              new IngestionConfig("ALGOLIA_APPLICATION_ID", "ALGOLIA_API_KEY", "ALGOLIA_APPLICATION_REGION")
            );

            // Call the API
            var response = await client.CreateAuthenticationAsync(
              new AuthenticationCreate
              {
                Type = Enum.Parse<AuthenticationType>("Oauth"),
                Name = "authName",
                Input = new AuthInput(
                  new AuthOAuth
                  {
                    Url = "http://test.oauth",
                    ClientId = "myID",
                    ClientSecret = "mySecret",
                  }
                ),
              }
            );

            // print the response
            Console.WriteLine(response);
        - lang: dart
          label: Dart
          source: |-
            // Initialize the client
            final client = IngestionClient(
                appId: 'ALGOLIA_APPLICATION_ID',
                apiKey: 'ALGOLIA_API_KEY',
                region: 'ALGOLIA_APPLICATION_REGION');

            // Call the API
            final response = await client.createAuthentication(
              authenticationCreate: AuthenticationCreate(
                type: AuthenticationType.fromJson("oauth"),
                name: "authName",
                input: AuthOAuth(
                  url: "http://test.oauth",
                  clientId: "myID",
                  clientSecret: "mySecret",
                ),
              ),
            );

            // print the response
            print(response);
        - lang: go
          label: Go
          source: >-
            // Initialize the client with your application region, eg.
            ingestion.ALGOLIA_APPLICATION_REGION

            client, err := ingestion.NewClient("ALGOLIA_APPLICATION_ID",
            "ALGOLIA_API_KEY", ingestion.US)

            if err != nil {
              // The client can fail to initialize if you pass an invalid parameter.
              panic(err)
            }


            // Call the API

            response, err :=
            client.CreateAuthentication(client.NewApiCreateAuthenticationRequest(
              ingestion.NewEmptyAuthenticationCreate().
                SetType(ingestion.AuthenticationType("oauth")).
                SetName("authName").
                SetInput(ingestion.AuthOAuthAsAuthInput(
                  ingestion.NewEmptyAuthOAuth().SetUrl("http://test.oauth").SetClientId("myID").SetClientSecret("mySecret"))),
            ))

            if err != nil {
              // handle the eventual error
              panic(err)
            }



            // print the response

            print(response)
        - lang: java
          label: Java
          source: >-
            // Initialize the client

            IngestionClient client = new
            IngestionClient("ALGOLIA_APPLICATION_ID", "ALGOLIA_API_KEY",
            "ALGOLIA_APPLICATION_REGION");


            // Call the API

            AuthenticationCreateResponse response = client.createAuthentication(
              new AuthenticationCreate()
                .setType(AuthenticationType.OAUTH)
                .setName("authName")
                .setInput(new AuthOAuth().setUrl("http://test.oauth").setClientId("myID").setClientSecret("mySecret"))
            );


            // print the response

            System.out.println(response);
        - lang: javascript
          label: JavaScript
          source: >-
            // Initialize the client

            // Replace 'us' with your Algolia Application Region

            const client = algoliasearch('ALGOLIA_APPLICATION_ID',
            'ALGOLIA_API_KEY').initIngestion({ region: 'us' });


            // Call the API

            const response = await client.createAuthentication({
              type: 'oauth',
              name: 'authName',
              input: { url: 'http://test.oauth', client_id: 'myID', client_secret: 'mySecret' },
            });



            // print the response

            console.log(response);
        - lang: kotlin
          label: Kotlin
          source: |-
            // Initialize the client
            val client =
              IngestionClient(
                appId = "ALGOLIA_APPLICATION_ID",
                apiKey = "ALGOLIA_API_KEY",
                region = "ALGOLIA_APPLICATION_REGION",
              )

            // Call the API
            var response =
              client.createAuthentication(
                authenticationCreate =
                  AuthenticationCreate(
                    type = AuthenticationType.entries.first { it.value == "oauth" },
                    name = "authName",
                    input =
                      AuthOAuth(url = "http://test.oauth", clientId = "myID", clientSecret = "mySecret"),
                  )
              )


            // print the response
            println(response)
        - lang: php
          label: PHP
          source: >-
            // Initialize the client

            $client = IngestionClient::create('ALGOLIA_APPLICATION_ID',
            'ALGOLIA_API_KEY', 'ALGOLIA_APPLICATION_REGION');


            // Call the API

            $response = $client->createAuthentication(
                ['type' => 'oauth',
                    'name' => 'authName',
                    'input' => ['url' => 'http://test.oauth',
                        'client_id' => 'myID',
                        'client_secret' => 'mySecret',
                    ],
                ],
            );



            // print the response

            var_dump($response);
        - lang: python
          label: Python
          source: >-
            # Initialize the client

            # In an asynchronous context, you can use IngestionClient instead,
            which exposes the exact same methods.

            client = IngestionClientSync(
                "ALGOLIA_APPLICATION_ID", "ALGOLIA_API_KEY", "ALGOLIA_APPLICATION_REGION"
            )


            # Call the API

            response = client.create_authentication(
                authentication_create={
                    "type": "oauth",
                    "name": "authName",
                    "input": {
                        "url": "http://test.oauth",
                        "client_id": "myID",
                        "client_secret": "mySecret",
                    },
                },
            )



            # print the response

            print(response)
        - lang: ruby
          label: Ruby
          source: >-
            # Initialize the client

            client = Algolia::IngestionClient.create("ALGOLIA_APPLICATION_ID",
            "ALGOLIA_API_KEY", "ALGOLIA_APPLICATION_REGION")


            # Call the API

            response = client.create_authentication(
              Algolia::Ingestion::AuthenticationCreate.new(
                type: "oauth",
                name: "authName",
                input: Algolia::Ingestion::AuthOAuth.new(url: "http://test.oauth", client_id: "myID", client_secret: "mySecret")
              )
            )



            # print the response

            puts(response)
        - lang: scala
          label: Scala
          source: |-
            // Initialize the client
            val client = IngestionClient(
              appId = "ALGOLIA_APPLICATION_ID",
              apiKey = "ALGOLIA_API_KEY",
              region = "ALGOLIA_APPLICATION_REGION"
            )

            // Call the API
            val response = Await.result(
              client.createAuthentication(
                authenticationCreate = AuthenticationCreate(
                  `type` = AuthenticationType.withName("oauth"),
                  name = "authName",
                  input = AuthOAuth(
                    url = "http://test.oauth",
                    clientId = Some("myID"),
                    clientSecret = Some("mySecret")
                  )
                )
              ),
              Duration(100, "sec")
            )

            // print the response
            println(response)
        - lang: swift
          label: Swift
          source: >-
            // Initialize the client

            let client = try IngestionClient(appID: "ALGOLIA_APPLICATION_ID",
            apiKey: "ALGOLIA_API_KEY", region: .us)


            // Call the API

            let response = try await
            client.createAuthentication(authenticationCreate:
            AuthenticationCreate(
                type: AuthenticationType.oauth,
                name: "authName",
                input: AuthInput.authOAuth(AuthOAuth(url: "http://test.oauth", clientId: "myID", clientSecret: "mySecret"))
            ))


            // print the response

            print(response)
        - lang: cURL
          label: curl
          source: |-
            curl --request POST \
              --url https://data.us.algolia.com/1/authentications \
              --header 'accept: application/json' \
              --header 'content-type: application/json' \
              --header 'x-algolia-api-key: ALGOLIA_API_KEY' \
              --header 'x-algolia-application-id: ALGOLIA_APPLICATION_ID' \
              --data '
            {
              "type": "googleServiceAccount",
              "name": "lorem",
              "platform": "bigcommerce",
              "input": {
                "clientEmail": "service-account-name@project-id.iam.gserviceaccount.com",
                "privateKey": "lorem"
              }
            }
            '
components:
  schemas:
    AuthenticationCreate:
      type: object
      description: Request body for creating a new authentication resource.
      additionalProperties: false
      properties:
        input:
          $ref: '#/components/schemas/AuthInput'
        name:
          $ref: '#/components/schemas/name'
        type:
          $ref: '#/components/schemas/AuthenticationType'
        platform:
          $ref: '#/components/schemas/Platform'
      required:
        - type
        - name
        - input
    AuthenticationCreateResponse:
      type: object
      description: API response for the successful creation of an authentication resource.
      additionalProperties: false
      properties:
        authenticationID:
          $ref: '#/components/schemas/authenticationID'
        createdAt:
          $ref: '#/components/schemas/CreatedAt'
        name:
          $ref: '#/components/schemas/name'
      required:
        - authenticationID
        - name
        - createdAt
    AuthInput:
      oneOf:
        - $ref: '#/components/schemas/AuthGoogleServiceAccount'
        - $ref: '#/components/schemas/AuthBasic'
        - $ref: '#/components/schemas/AuthAPIKey'
        - $ref: '#/components/schemas/AuthOAuth'
        - $ref: '#/components/schemas/AuthAlgolia'
        - $ref: '#/components/schemas/AuthAlgoliaInsights'
        - $ref: '#/components/schemas/AuthSecrets'
    name:
      type: string
      description: Descriptive name for the resource.
    AuthenticationType:
      type: string
      description: >-
        Type of authentication. This determines the type of credentials required
        in the `input` object.
      enum:
        - googleServiceAccount
        - basic
        - apiKey
        - oauth
        - algolia
        - algoliaInsights
        - secrets
    Platform:
      default: null
      oneOf:
        - type: string
          description: |
            Name of an ecommerce platform with which to authenticate.
            This determines which authentication type you can select.
          enum:
            - bigcommerce
            - commercetools
            - shopify
        - type: 'null'
    authenticationID:
      type: string
      description: Universally unique identifier (UUID) of an authentication resource.
      example: 6c02aeb1-775e-418e-870b-1faccd4b2c0f
    CreatedAt:
      type: string
      description: Date and time when the resource was created, in RFC 3339 format.
    ErrorBase:
      description: Error.
      type: object
      x-keep-model: true
      additionalProperties: true
      properties:
        message:
          type: string
          example: Invalid Application-Id or API-Key
    AuthGoogleServiceAccount:
      title: Google
      type: object
      description: >-
        Credentials for authenticating with a Google service account, such as
        BigQuery.
      additionalProperties: false
      properties:
        clientEmail:
          type: string
          description: Email address of the Google service account.
          example: service-account-name@project-id.iam.gserviceaccount.com
        privateKey:
          type: string
          description: >-
            Private key of the Google service account. This field is `null` in
            the API response.
      required:
        - clientEmail
        - privateKey
      x-discriminator-fields:
        - clientEmail
        - privateKey
    AuthBasic:
      title: Basic
      type: object
      description: Credentials for authenticating with user name and password.
      additionalProperties: false
      properties:
        password:
          type: string
          description: Password. This field is `null` in the API response.
        username:
          type: string
          description: Username.
      required:
        - username
        - password
      x-discriminator-fields:
        - username
        - password
    AuthAPIKey:
      title: API key
      type: object
      description: Credentials for authenticating with an API key.
      additionalProperties: false
      properties:
        key:
          type: string
          description: API key. This field is `null` in the API response.
      required:
        - key
      x-discriminator-fields:
        - key
    AuthOAuth:
      title: OAuth 2.0
      type: object
      description: Credentials for authenticating with OAuth 2.0.
      additionalProperties: false
      properties:
        url:
          type: string
          description: URL for the OAuth endpoint.
        client_id:
          type: string
          description: Client ID.
        client_secret:
          type: string
          description: Client secret. This field is `null` in the API response.
        code:
          type: string
          description: >
            Authorization code.

            Used during an `authorization_code` grant type flow, to request an
            access_token when creating/updating the authentication.

            This field is not returned in the API response.
        scope:
          type: string
          default: ''
          description: OAuth scope.
      required:
        - url
      x-discriminator-fields:
        - url
        - client_id
        - client_secret
        - code
    AuthAlgolia:
      title: Algolia
      type: object
      additionalProperties: false
      description: Credentials for authenticating with Algolia.
      properties:
        apiKey:
          type: string
          description: >
            Algolia API key with the ACL: `addObject`, `deleteObject`,
            `settings`, `editSettings`, `listIndexes`, `deleteIndex`.

            This field is `null` in the API response.
        appID:
          type: string
          description: Algolia application ID.
      required:
        - appID
        - apiKey
    AuthAlgoliaInsights:
      title: Algolia Insights
      type: object
      additionalProperties: false
      description: Credentials for authenticating with the Algolia Insights API.
      properties:
        apiKey:
          type: string
          description: |
            Algolia API key with the ACL: `search`.
            This field is `null` in the API response.
        appID:
          type: string
          description: Algolia application ID.
      required:
        - appID
        - apiKey
    AuthSecrets:
      title: Key:value
      type: object
      description: A key:value authentication for your transformations.
      additionalProperties:
        type: string
  responses:
    BadRequest:
      description: Bad request or request arguments.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorBase'
  securitySchemes:
    appId:
      type: apiKey
      in: header
      name: x-algolia-application-id
      description: Your Algolia application ID.
    apiKey:
      type: apiKey
      in: header
      name: x-algolia-api-key
      description: >
        Your Algolia API key with the necessary permissions to make the request.

        Permissions are controlled through access control lists (ACL) and access
        restrictions.

        The required ACL to make a request is listed in each endpoint's
        reference.

````